﻿**cpcc - Cross Platform C++ Classes**

A set of cross platform classes and functions.

(c) StarMessage Software [http://www.StarMessageSoftware.com/cpcclibrary]


**Project Objectives:**

A small set of cross platform classes and functions that will allow the quick development of applications.

**Designed for ease of use:**

- Simply include the needed files in your project.
  No need to build the classes as a separate libraries (release + debug version) and then link the library with your code
- Self test routines on most units.   
- Implemented in header-only files whenever possible.

**Operating system compatibility:**

Already tested under:
- Windows XP and later, 32 and 64 bit
- OSX 10.6+  

Future compatibility: 
- IOS

**Project status:**

Classes in the current queue:
- [ok] portable fileSystem
- [ok] portable log file
- [ok] portable INI-like persistence class
- [ok] portable screensaver API class
- [ok] Listener pattern
- [ok] Gui drawing tools (HDC: Ok, NSView [Ok], NSImage [ ], NSBmpRepresentation [ ] 
- [ok] portable window class with drawing tools
- [ok] portable image class with drawing tools
- [ok] Windows GDI helper class with common GDI drawing objects (Brush, HBITMAT, HFONT, etc).
- [ok] Cross platform (Windows, OSX) getComputerName() function
- [  ] Cross platform getComputerID function
- [  ] IOS compatibility


[![HitCount](http://hits.dwyl.io/starmessage/badges.svg)](https://www.starmessagesoftware.com/)
[![Analytics](https://ga-beacon.appspot.com/UA-385839-11/github.com/starmessage/cpcc/README.md)](https://GitHub.com/starmessage/cpcc)

